# 将dune 上 special的add 的swap和transfer合并在一起
import pandas as pd
import sys
import re
import datetime
import pytz

def makeurl( url,url_show):
    return '=HYPERLINK("{}","{}")'.format(url,  url_show)
def get_nowdate():

    timestamp = datetime.datetime.now().timestamp()
    # print(timestamp)
    dt = datetime.datetime.fromtimestamp(timestamp)
    tz = pytz.timezone('Asia/Shanghai')
    normal_time_str = dt.astimezone(tz).strftime('%Y-%m-%d %H:%M:%S')
    time_str = dt.astimezone(tz).strftime('%m%d%H%M')
    return time_str
def utc_2_shanghaidate(df , utc_time_col ):
# 将字符串转换为UTC时间的datetime对象
    df[utc_time_col] = pd.to_datetime(df[utc_time_col], utc=True)
    # 定义UTC+8时区
    utc_plus_8 = pytz.timezone('Asia/Shanghai')
    # 转换为UTC+8时间
    # df['shanghai_date'] = df['shanghai_date'].dt.tz_convert(utc_plus_8)
    # # 提取时间字符串
    # df['shanghai_date'] = df['shanghai_date'].dt.strftime('%Y-%m-%d %H:%M')
    df[utc_time_col] = df[utc_time_col].dt.tz_convert(utc_plus_8)
    # 提取时间字符串
    df[utc_time_col] = df[utc_time_col].dt.strftime('%Y-%m-%d %H:%M')
    return df
 


def main():
    df_swap_row = pd.read_excel('merge_swap_transfer_row.xlsx'  )
    df_swap_row= df_swap_row[df_swap_row['trader_id'].isin(arr_trader)].reset_index(drop=True)
    df_swap_row['block_time'] = pd.to_datetime(df_swap_row['block_time'])
    
    
    df_swap_row =df_swap_row[
 (   df_swap_row['block_time']>pd.Timestamp(start_datetime) )
    & (df_swap_row['block_time']<=pd.Timestamp(end_datetime))
    
    ].reset_index(drop=True)


    df_swap_row["oklink"] = df_swap_row.apply(lambda ser: makeurl(
     f"https://www.oklink.com/zh-hans/sol/tx/{ser['tx_id']}" , "oklink" ), axis=1)

    df_swap_row["scan"] = df_swap_row.apply(lambda ser: makeurl(
     f"https://solscan.io/tx/{ser['tx_id']}" , "scan" ), axis=1)
    
    
    df_swap_row.to_excel(  f'merge_swap_transfer_total_info_{str_start}-{str_end}.xlsx'  ,index=False)
    
 
    return

start_datetime =   '2025-01-09 01:00:00'
end_datetime = '2025-01-16 02:00:00'

 
str_start =  re.split(r'[- :]', start_datetime)
str_start =  str_start[1]+str_start[2]+ '日'+ str_start[3]+str_start[4]

str_end =  re.split(r'[- :]', end_datetime)
str_end =  str_end[1]+str_end[2]+ '日'+ str_end[3]+str_end[4]



 
arr_trader = [

'5Q544fKrFoe6tsEbD7S8EmxGTJYAKtTVhAW5Q5pge4j1',
'Cet3TXGhtFcBo6vX9kfYjbtNyANbCWqwVC6G1QioKUhc',
'7m2XQP2NDebaEKDhegj7WYpZBmrKF5yhiVi1JZU8cwoj',
'68WLD7YzwjqBoCEVuJ3rjVbaPaAog6ATCkjUTpNqiMNF',
'4ttYJgVcZMMXFsTPBAEKVUEDUshvsXqgvfUv3W7bdv7e',
'14qLxu9XDQtc2pgnxX2SSdWPpnuVrEqccgwmATH1khcY',
'Hh6XswyZK9WPUbb6csqi7YggDqYTstKkHFvvh7PFx7kw',
'DAr4CE2rFgvtDHSFG75rEhmxmqgfEQYir91RGY458pkZ',
'CC1xmUJCvq4wPzHSNKVHfMV9T3vRjHTZnzvW9VLVJ4gs',
'GDwiC6S14topnYmWquQb6JdQxrRsvtH7N3K8UCLZmVrk',
'HjUrUJi7zUCXu6NpXBUujYsoG5TJsXkPUrYJdWMKVtts',
'5PZs2fmTJpjaMhYbdAH6uEx7Jbbhy2RdAdkNnPw83H3a',
'FH8xnCwgoQgk3nXuePEdxYB5SZDTWSZav27smVcHjN1q',
'ET3VpuSMr15ufn4z9a5kwHhyLRse2H96TY2HXVKZxCJM',
'GD9Q87EY9guqAqkxgNwiqoqUKmBs958tcFEkQ8q1HD1N',
'5pW6xYQZxZLs67eKuurGcTVm2nHqFcDsiuxesqagoW6V',
'7V7BFFLNgHhrJq7Udm9Zi26Tbgvytg9GWKLdDLRzf4z6',
'BC8yiFFQWFEKrEEj75zYsuK3ZDCfv6QEeMRif9oZZ9TW',
'6QfdT1XZauUMCJU3SaN2d2aqdoFa4TDVNmxJig52ZGZT',
'3M2dQzm6kz9ChDfaeX3xxqzn8BdeLjJEJv9JBd9WG2Jx',
'6xMPaDn8jZ1r68BzXAunvumU8BTG2vDbgemNkWwRd1Fo',
'3UFHt8qqRtHM2hZaCYRGKaF1gYfePcRYZFo2CdaadfMa',
'Aewfbg61nn3SrFikqTsX2c8nZM8DXVbG7jpUp1Qwg22H',
'3kZ7ZYjUGSFMhXbQ3twdCmqP1cgCjjBbZHRd8eXFFaja',
'E9EpirpCKqJKnUTfhpUKzDKKFzVd7Q8RjjbdRVjPxXWX',
'3Q7bWprdJZ5JUDoy2wBAcoKzgp7mZ3ChPaR8o3SUf7EN',
'27NdJihiGpbg1kgHwAjk4UDUScTjEg7BDTo6urHjB3Cr',
'BTJk52ULuadhdzYWpK2io1urPVfqEpqoH3sS4yg4b8Z2',
'2fnRmNSYMTuyGw58UdZTrEgb2NmjNXvyRzqU9FJG31Q6',
'GE5PnwZTgWw1YqVGno2QPWqie6aLjswNeGFhiF1nDg3k',
'9r7p8uQiwRMRqQwAGDHUQ1Lmtjt4auNTxK7TgWg75J7C',
'4N41X5S1GaqKQhZvqQsE7aKCpEm2xhswKTznQoxuJEmv',
'FT78Vsmv2hWj8PK9HN1rtGEdKtt4Ajd2RSsxhrUt5nVG',
'FML97BaUTVJX15T8tCU5LUbcpvJkHQ5RcZXmV354PzRt',
'CpVNBP8bbFvT7Yt3zwTnCaXt26XojQxduNXaMz57DGLf',
'77RWuJjzTgswsgUafvhSNDAbGxHcUHQPZ3ogpvNr3eB',
'3ddwpbz7aXr6ZD7ybMZcUMTm76pgeszJekSkLdS931EH',
'4KaVawPKmG1RZCv698XD9YzRsJcFPXrEoYnZbdZmfFFq',
'HRL9mVQav58fLGJpN16qT55nXuk8S7Lx33Gvw2SHRHK5',
'AeqgApsq3CoopttTpohuLiXj53EauJ78ophVvy8hrfkt',
'51pcMTBEKwiKRVrCV5EmmHazsWetGDUxKkxoc5r3248',
'5pKTV6EhcyFQPBbEDEATyDiUHM4kDZddtopRLq7o8kJj',
'66VSSN5FiwkDXCSJ5ydNCZm8RD1DwVKXuwaeFBGJ5fKg',
'3qTNSWq6o7hfb7RgSz6GzxDMNLgrjVuwKqFD2kJznuRB',
'3fZcDhWXTBvNMkgzkyMmqxMizfysnvFZw5CzR7pnuxRz',
'F8pWbg5zGXnzghmAtNW9SQPQYwP1RkyzsHs6KZTBh7Dg',
'DuDEvMussH5iKvBPaa6mSVyJY39fPQKNEPUyT5c19S2x',
'98oWTwQBBEyhhLMcUrgy2gta7zmVHZavQmcS8z98PDHe',
'EPS4j3XEBas8okzQCe2CeuwKf6w6aif5ED4GMj3mqv4r',
'5Xu8p9emHTkuNQkPN6D2ygkJypWo1nbUzbjYHUfXcNuR',
'Hk7gzrcANZpqBnYCHeBEuxFk18HLu9Tey7TrNroyPVK7',
'Goc5dPcEM94cFW97k92XNoT45vR89isxSEjxqE3VTvhv',
'A3wcLYiBQdW5Uf5TXxbvuueJYh8pfAy57cbuE5fQJBeS',
'D6DLAnP1NnimNYuHNDhJZfGkD1TmiKENWG2PrdhL8qLP',
'CGnKC5zME8G36ftGLq1wrmQxw3SUgzVojJmVNXpidC6k',
'8oTVjgucrArfQgyGFy2AiEKz6QDhW6ATTJQ1nSkG3wAr',
'4k22yKKbCsrq7QhCd89ZXFcxhSbGmszA92H2KhthpgKq',
'dR4GCDofsA6ZpBqzQpQJeob4msVspyASATbqW4sC4YM',
'DNfuF1L62WWyW3pNakVkyGGFzVVhj4Yr52jSmdTyeBHm',
'2ANPc28rr67W8StfCFzfuY3ZbKp9FCJ9tfBc17pRK7sY',
'9cQcY83s45VsMwVmFHFUR2HVG5j9Rc3K8HU4hzLaXnWs',
'HjHBsicgsMqSrU9VPSas8sKYLGtCfwMzfiYHzfMEta6f',
'5c511kvVfCGrEsLkNb6RoVqqA5BpimGHyhkE3ki4kWkX',
'7xgxtHJX21bvXozPsmyVCi88qChqxZR4e84ckXgrTeFp',
'D7hpLQ4VEKAr2ALHZqT7JjTLqgBGsRqJZrbfzxPcyVtD',
'6mh7mv8JGBqmnV86NFJoVS3fkYgdbxCmxVys1vK3dB6t',
'3v6XiVAbays5FiZy6sWuriLHfC77EAX9mtB57Hf8VmpQ',
'Gy5GSoHmrfnv49TZHku1bxNv2Dy4tFDjgm7vGbmp8S2h',
'2geGo4wz6KgBb84Az6MM8w1dDnXoW6wmyX3hkEstAXJw',
'9UPcMHdTw8pJSvv13dH1tGawwCjSCSjjxwU5cKu9PTiq',
'2k77ScTf9ULptpVRG4M4X6SRZiuUxWCTzG2RWBT7KnHR',
'9wNu1SLCfouEsR4B8PCck6p15mcSgun7k5KEKDw43Cyu',
'3nxNfz8fx4DPW37i97Qs4Ue4Z2zVinEFeDAAymwtEtYd',
'Gg6PuMT9qs53QiSrrJsnLyh51xedbzKAV5JiQ9qHPQ7a',
'7JYCpRR4ZnKnMuxgiRta6ogs1BrC1aURW7iZdiJytsPB',
'2ydwYpyTwn1NrPpRN4n6NaHHtg82G65QAN2rQxX6e9ep',
'AR6SjcFLzQoZXXLVbaKo4GbsvmKmKKobCfrXFHcqE6TN',
'8Mnb87uUYXcqejP6RuUyDiX9Fd1unCA3YdM3zLGSVEPQ',
'CfpFiySF5c63fvgtjjgbefjS2JSATJYeqp8qFQX76hKT',
'CdCM27tboWquCEC3Pq3CRphSdiGV6Q48VewWmrxbUyYW',

]


if __name__ == "__main__":
 
 
    main()